# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import popuplib
import playerlib
# ============================================================================================================================================================= #

# * ADMINS LOAD
es.load('sam/admins')

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Load Modules '''
	es.load('sam/base/manager')
	es.load('sam/base/pcontrol')
	es.load('sam/base/addons')

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Unloads '''
	es.unload('sam/base/manager')
	es.unload('sam/base/pcontrol')
	es.unload('sam/base/addons')
	es.unload('sam/admins')

	''' Popups '''
	func.popupDelete('mainPage')

# ============================================================================================================================================================= #
# ======================================================================= CMD BLOCKS ========================================================================== #
# ============================================================================================================================================================= #
def menuCMD(userid = None):
	if userid == None: userid = es.getcmduserid()
	if admins.checkDB():
		if admins.isAdmin(es.getplayersteamid(userid)): displayMenu(userid)
	else: admins.firstAdmin(userid)

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def displayMenu(userid):
	func.popupDelete('mainPage')
	popup = popuplib.create('mainPage')
	popup.addline('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.addline('\n \n :: ' + func.commonText('mainPage_title', None, func.getLang()))
	popup.addline(func.pline)
	popup.addline('->1. ' + func.commonText('mainPage_pcontrol', None, func.getLang()))
	popup.addline('->2. ' + func.commonText('mainPage_mapChanger', None, func.getLang()))
	popup.addline('->3. ' + func.commonText('mainPage_addons', None, func.getLang()))
	popup.addline('->4. ' + func.commonText('mainPage_admins', None, func.getLang()))
	popup.addline(' ')
	popup.addline(func.pline)
	popup.addline('0. ' + func.commonText('cancel', None, func.getLang()))
	popup.select(1, pcontrol)
	popup.select(2, mapChanger)
	popup.select(3, addons)
	popup.select(4, manager)
	if int(es.ServerVar('sam_first_admin')) == 0: popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def pcontrol(userid, choice, popup):
	block = es.import_addon('sam/base/pcontrol')
	block.modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def mapChanger(userid, choice, popup):
	if es.ServerVar('sam_mapchange') == 1:
		block = es.import_addon('sam/base/addons/mapchange')
		block.modulePopup(userid)
	else:
		func.hudhint(userid, func.commonText('notLoaded', None, func.getLang()), 'SAM ::')
		displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def addons(userid, choice, popup):
	if admins.checkAccess(es.getplayersteamid(userid), 'Addons Manager'):
		block = es.import_addon('sam/base/addons')
		block.modulePopup(userid)
	else: displayMenu(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def manager(userid, choice, popup):
	if admins.checkAccess(es.getplayersteamid(userid), 'Admins Manager'):
		block = es.import_addon('sam/base/manager')
		block.modulePopup(userid)
	else: displayMenu(userid)

# ============================================================================================================================================================= #
# ========================================================================= BLOCKS ============================================================================ #
# ============================================================================================================================================================= #
def reloadCMD(): es.reload('sam')

# ============================================================================================================================================================= #