# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import popuplib
import playerlib
import langlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/admins')

# * VARIABLES

Global = ['Kick','Ban']
Alive  = ['Slay']
Dead   = []
Others = ['Move Players','Unban']

# '''''''''''''''''''''' # Languages # ''''''''''''''''''''' #
popupText = langlib.Strings(es.getAddonPath('sam') + '/langs/pcontrol/popups.ini')
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	''' Loads '''
	for x in (Global, Alive, Others, Dead):
		for item in x: es.load('sam/base/pcontrol/' + item.replace(' ','').lower())

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	''' Unloads '''
	for x in (Global, Alive, Others, Dead):
		for item in x: es.unload('sam/base/pcontrol/' + item.replace(' ','').lower())

	''' Popups '''
	func.popupDelete('pcontrol')
	func.popupDelete('pcontrol_getTarget')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def modulePopup(userid):
	func.popupDelete('pcontrol')
	popup = popuplib.easymenu('pcontrol', None, pcontrol_Choice)
	popup.c_beginsep = '-' * 45
	popup.c_pagesep  = '-' * 45
	popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
	popup.setdescription('\n \n :: ' + func.commonText('mainPage_pcontrol', None, func.getLang()))
	for x in (Global, Alive, Others, Dead):
		for item in x: popup.addoption(item, func.commonText(item.replace(' ','').lower(), None, func.getLang()))
	popup.submenu(10, 'mainPage')
	popup.send(userid)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def pcontrol_Choice(userid, choice, popup):
	if admins.checkAccess(es.getplayersteamid(userid), choice):
		if choice in Others: sendTo_Others(userid, choice.replace(' ','').lower(), None)
		else:
			func.popupDelete('pcontrol_getTarget')
			popup = popuplib.easymenu('pcontrol_getTarget', None, sendTo_Module)
			popup.c_beginsep = '-' * 45
			popup.c_pagesep  = '-' * 45
			popup.settitle('%s | SAM %s' % (es.ServerVar('sam_menutitle'), es.ServerVar('sam_version')))
			popup.setdescription('\n \n :: %s\n# %s' % (popupText('%sTitle' % choice.replace(' ','').lower(), None, func.getLang()), popupText('%sDesc' % choice.replace(' ','').lower(), None, func.getLang())))
			popup.submenu(10, 'pcontrol')
			if choice in Global:
				for player in playerlib.getPlayerList('#human'): popup.addoption({'choice':choice.replace(' ','').lower(), 'target':player}, player.name)
				popup.send(userid)
			elif choice in Alive:
				alive = playerlib.getPlayerList('#alive')
				if len(alive) > 0:
					for player in alive: popup.addoption({'choice':choice.replace(' ','').lower(), 'target':player}, player.name)
					popup.send(userid)
				else: 
					func.hudhint(userid, func.commonText('noPlayersInTeams', None, func.getLang()))
					modulePopup(userid)
			elif choice in Dead:
				dead = playerlib.getPlayerList('#dead')
				if len(dead) > 0:
					for player in dead: popup.addoption({'choice':choice.replace(' ','').lower(), 'target':player}, player.name)
					popup.send(userid)
				else: 
					func.hudhint(userid, func.commonText('noPlayersDead', None, func.getLang()))
					modulePopup(userid)
			else: modulePopup(userid)
	else: modulePopup(userid)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendTo_Module(userid, choice, popup):
	func.popupDelete(popup)
	admin  = playerlib.getPlayer(userid)
	target = playerlib.getPlayer(choice['target'])
	block  = es.import_addon('sam/base/pcontrol/' + choice['choice'])
	block.moduleAction(admin,target)

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def sendTo_Others(userid, choice, popup):
	func.popupDelete(popup)
	block = es.import_addon('sam/base/pcontrol/' + choice)
	if choice == 'moveplayers': block.moduleAction(userid)
	elif choice == 'unban': block.moduleAction(userid)

# ============================================================================================================================================================= #